<!doctype html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>CardCaptcha</title>
<style type="text/css">
form > button > img {
    width: 60px;
    height: auto;
}
</style>
</head>
<body>
<h1>CardCaptcha - Captcha with Playing Cards</h1>
<form method="POST">
<?php
////// You can change me! //////
$CC_choices = 4;
$CC_unique = "30dnqk38"; // IMPORTANT: CHANGE THIS!
////////////////////////////////
$CC_suits = array(
    "s" => "spades",
    "c" => "clubs",
    "h" => "hearts",
    "d" => "diamonds"
);
$CC_values = array(
    "2" => "two",
    "3" => "three",
    "4" => "four",
    "5" => "five",
    "6" => "six",
    "7" => "seven",
    "8" => "eight",
    "9" => "nine",
    "t" => "ten",
    "j" => "jack",
    "q" => "queen",
    "k" => "king",
    "a" => "ace",
);
function CC_hash($string, $key) {
    for($i = 0; $i < strlen($string); $i++) 
        $string[$i] = ($string[$i] ^ $key[$i % strlen($key)]); // XOR string with key
    return hash("sha256", $string); // SHA-256 hash
}
if (empty($_POST)) {
    $CC_answer = mt_rand(1, $CC_choices);
    $CC_answer_string = "";
    $CC_answer_card = "";
    for ($i = 1; $i <= $CC_choices; $i++) {
        $suit = array_rand($CC_suits, 1);
        $value = array_rand($CC_values, 1);
        $path = __DIR__.'/cards/'.$value.$suit.'.png';
        $base64 = 'data:image/png;base64,' . base64_encode(file_get_contents($path));
        $hash = CC_hash($value.$suit, $CC_unique);
        echo '<button name="cc_card" value="'.$hash.'"><img src="'.$base64.'"></img></button>'.PHP_EOL;
        if($i === $CC_answer) {
            $CC_answer_string = $CC_values[$value]." of ".$CC_suits[$suit];
            $CC_answer_card = $value.$suit;
        }
    }
    echo '<input type="hidden" name="cc_answer" value="'.$CC_answer_card.'">'.PHP_EOL.'</form>'.PHP_EOL;
    echo "<p>Select the ".$CC_answer_string."</p>";
} else {
    if(isset($_POST["cc_card"]) && isset($_POST["cc_answer"])) {
        if($_POST["cc_card"] === CC_hash($_POST["cc_answer"], $CC_unique)) {
            echo 'Correct! <a href=".">Try again</a>';
        } else {
            echo 'Incorrect! <a href=".">Try again</a>';
        }
    } else {
        echo "Invalid POST data";
    }
}

?>
</body>
</html>